
void sendToMatrix(byte addr, byte data) {
  digitalWrite(CS, LOW);
  SPI.transfer(addr);
  SPI.transfer(data);
  digitalWrite(CS, HIGH);
}

void moveTo(byte mx, byte my) {
  if (my != y) {
    sendToMatrix(y + 1, 0);
    y = my;
  }
  x = mx;
  sendToMatrix(y + 1, 1 << x);  
}

void clearMatrix() {
  for (byte i = 1; i < 9; i++) {
    sendToMatrix(i, 0);
  }
}

void clearBuffer() {
  for (byte i = 0; i < 8; i++) {
    buffer[i] = 0;
  }
}
/*
void imgPart(byte mx, byte my) {
  for (byte i = 0; i < 8; i++) {
    buffer[i] = img[my + i] >> mx;
    sendToMatrix(i + 1, buffer[i]);  
  }
}

void writeImg(byte* image) {
  for (byte i = 0; i < 8; i++) {
    //buffer[i] = image[i];
    sendToMatrix(i + 1, image[i]);
  }
}
*/
void writeRows(byte r1, byte r2, byte r3, byte r4, byte r5, byte r6, byte r7, byte r8) {
  sendToMatrix(1, r1);
  sendToMatrix(2, r2);
  sendToMatrix(3, r3);
  sendToMatrix(4, r4);
  sendToMatrix(5, r5);
  sendToMatrix(6, r6);
  sendToMatrix(7, r7);
  sendToMatrix(8, r8);
}

void bufferRows(byte* buff, byte r1, byte r2, byte r3, byte r4, byte r5, byte r6, byte r7, byte r8) {
  buff[0] = r1;
  buff[1] = r2;
  buff[2] = r3;
  buff[3] = r4;
  buff[4] = r5;
  buff[5] = r6;
  buff[6] = r7;
  buff[7] = r8;
}

void updateMatrix() {
  for (byte i = 0; i < 8; i++) {
    sendToMatrix(i + 1, buffer[i]);
  }
}
/*
void writeXY(byte mx, byte my) {
  buffer[my] |= 1 << mx;
  sendToMatrix(my + 1, buffer[my]);  
}

void clearXY(byte mx, byte my) {
  buffer[my] &= ~(1 << mx);
  sendToMatrix(my + 1, buffer[my]);  
}
*/
void writeRect(byte x1, byte y1, byte x2, byte y2) {
  for (byte i = y1; i <= y2; i++) {
    for (byte j = x1; j <= x2; j++) {
      buffer[i] |= 1 << j;
    }
    sendToMatrix(i + 1, buffer[i]);    
  }
}
/*
void clearRect(byte x1, byte y1, byte x2, byte y2) {
  for (byte i = y1; i <= y2; i++) {
    for (byte j = x1; j <= x2; j++) {
      buffer[i] &= ~(1 << j);
    }
    sendToMatrix(i + 1, buffer[i]);    
  }
}

void writeLine(byte x1, byte y1, byte x2, byte y2) {
  char di = (y1 > y2) ? -1 : 1;
  char dj = (x1 > x2) ? -1 : 1;
  if (di * (y2 - y1) < dj * (x2 - x1)) {
    for (byte j = x1; char(dj * (x2 - j)) >= 0; j += dj) {
      buffer[y1 + (j - x1) * (y2 - y1 + di) / (x2 - x1 + dj)] |= 1 << j;
    }
    for (byte i = y1; char(di * (y2 - i)) >= 0; i += di) {
      sendToMatrix(i + 1, buffer[i]);    
    }
  }
  else {
    for (byte i = y1; char(di * (y2 - i)) >= 0; i += di) {
      buffer[i] |= 1 << x1 + (i - y1) * (x2 - x1 + dj) / (y2 - y1 + di);
      sendToMatrix(i + 1, buffer[i]);  
    }
  }
}

void clearLine(byte x1, byte y1, byte x2, byte y2) {
  char di = (y1 > y2) ? -1 : 1;
  char dj = (x1 > x2) ? -1 : 1;
  if (di * (y2 - y1) < dj * (x2 - x1)) {
    for (byte j = x1; char(dj * (x2 - j)) >= 0; j += dj) {
      buffer[y1 + (j - x1) * (y2 - y1 + di) / (x2 - x1 + dj)] &= ~(1 << j);
    }
    for (byte i = y1; char(di * (y2 - i)) >= 0; i += di) {
      sendToMatrix(i + 1, buffer[i]);    
    }
  }
  else {
    for (byte i = y1; char(di * (y2 - i)) >= 0; i += di) {
      buffer[i] &= ~(1 << x1 + (i - y1) * (x2 - x1 + dj) / (y2 - y1 + di));
      sendToMatrix(i + 1, buffer[i]);  
    }
  }
}
*/
